%{
#include "smtlib_lexer.h"

#define YY_DECL enum token smtlib_lex(void)
%}

%option prefix="smtlib_"
%option noyywrap

ws   [\t ]+
linebreak [\n]

%%
{ws} { } /* skip whitespace */
{linebreak} { smtlib_lineno++; }
"("    { return LPAREN; }
")"    { return RPAREN; }
"and"  { return AND; }
"or"  { return OR; }
"iff"  { return IFF; }
"not"  { return NOT; }
"flet"  { return FLET; }
"let"  { return LET; }
"distinct"  { return DISTINCT; }
"if_then_else"  { return IF_THEN_ELSE; }
"ite"  { return ITE; }
"benchmark"  { return BENCHMARK; }
"="   { return EQUAL; }
"<"   { return LESS; }
">"   { return GREATER; }
"<="   { return LESS_EQ; }
">="   { return GREATER_EQ; }
[-+]?[0-9]+ { return INTEGER; }
"+" { return PLUS; }
"-" { return MINUS; }
"*" { return MULTIPLY; }
"/" { return DIVIDE; }
"~" { return NEG; }
":" { return COLON; }
"sat" { return KW_SAT; }
"unsat" { return KW_UNSAT; }
"unknown" { return KW_UNKNOWN; }
"source" { return SOURCE; }
"status" { return STATUS; }
"category" { return CATEGORY; }
"logic" { return LOGIC; }
"difficulty" { return DIFFICULTY; }
"extrapreds" { return EXTRAPREDS; }
"extrafuns" { return EXTRAFUNS; }
"notes" { return NOTES; }
"formula" { return FORMULA; }
[a-zA-Z$_?][a-zA-Z0-9$_?.]* { return IDENTIFIER;}
\{[^}]*\} { return STRING; }
\"[^"]*\" { return STRING; }
<<EOF>> { return END_OF_FILE; }
%%